/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VIsSubdepartmentRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VIsSubdepartment extends TableImpl<VIsSubdepartmentRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_is_subdepartment</code>
     */
    public static final VIsSubdepartment V_IS_SUBDEPARTMENT = new VIsSubdepartment();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VIsSubdepartmentRecord> getRecordType() {
        return VIsSubdepartmentRecord.class;
    }

    /**
     * The column <code>common_dd.v_is_subdepartment.key_element</code>.
     */
    public final TableField<VIsSubdepartmentRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_is_subdepartment.dn</code>.
     */
    public final TableField<VIsSubdepartmentRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    private VIsSubdepartment(Name alias, Table<VIsSubdepartmentRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VIsSubdepartment(Name alias, Table<VIsSubdepartmentRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
         create view "v_is_subdepartment" as  SELECT t_core_element_hierarchy.key_element,
            t_core_element_hierarchy.dn
           FROM common_dd.t_core_element_hierarchy
        EXCEPT
         SELECT v_is_variable.key_element,
            v_is_variable.dn
           FROM common_dd.v_is_variable
        EXCEPT
         SELECT v_is_form.key_element,
            v_is_form.dn
           FROM common_dd.v_is_form
        EXCEPT
         SELECT v_is_department.key_element,
            v_is_department.dn
           FROM common_dd.v_is_department
        EXCEPT
         SELECT v_is_study.key_element,
            v_is_study.dn
           FROM common_dd.v_is_study
        EXCEPT
         SELECT v_is_studygroup.key_element,
            v_is_studygroup.dn
           FROM common_dd.v_is_studygroup;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_is_subdepartment</code> table
     * reference
     */
    public VIsSubdepartment(String alias) {
        this(DSL.name(alias), V_IS_SUBDEPARTMENT);
    }

    /**
     * Create an aliased <code>common_dd.v_is_subdepartment</code> table
     * reference
     */
    public VIsSubdepartment(Name alias) {
        this(alias, V_IS_SUBDEPARTMENT);
    }

    /**
     * Create a <code>common_dd.v_is_subdepartment</code> table reference
     */
    public VIsSubdepartment() {
        this(DSL.name("v_is_subdepartment"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VIsSubdepartment as(String alias) {
        return new VIsSubdepartment(DSL.name(alias), this);
    }

    @Override
    public VIsSubdepartment as(Name alias) {
        return new VIsSubdepartment(alias, this);
    }

    @Override
    public VIsSubdepartment as(Table<?> alias) {
        return new VIsSubdepartment(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsSubdepartment rename(String name) {
        return new VIsSubdepartment(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsSubdepartment rename(Name name) {
        return new VIsSubdepartment(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsSubdepartment rename(Table<?> name) {
        return new VIsSubdepartment(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsSubdepartment where(Condition condition) {
        return new VIsSubdepartment(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsSubdepartment where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsSubdepartment where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsSubdepartment where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsSubdepartment where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsSubdepartment where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsSubdepartment where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsSubdepartment where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsSubdepartment whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsSubdepartment whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
